Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs	(revision 3504)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs	(revision 3505)
@@ -89,6 +89,6 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.problemTabPage);
       this.tabControl.Controls.Add(this.parametersTabPage);
-      this.tabControl.Controls.Add(this.problemTabPage);
       this.tabControl.Controls.Add(this.resultsTabPage);
       this.tabControl.Controls.Add(this.runsTabPage);
@@ -106,5 +106,5 @@
       this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
       this.parametersTabPage.Size = new System.Drawing.Size(671, 374);
-      this.parametersTabPage.TabIndex = 0;
+      this.parametersTabPage.TabIndex = 1;
       this.parametersTabPage.Text = "Parameters";
       this.parametersTabPage.UseVisualStyleBackColor = true;
@@ -131,5 +131,5 @@
       this.problemTabPage.Padding = new System.Windows.Forms.Padding(3);
       this.problemTabPage.Size = new System.Drawing.Size(671, 374);
-      this.problemTabPage.TabIndex = 1;
+      this.problemTabPage.TabIndex = 0;
       this.problemTabPage.Text = "Problem";
       this.problemTabPage.UseVisualStyleBackColor = true;
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs	(revision 3504)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs	(revision 3505)
@@ -45,5 +45,4 @@
     /// </summary>
     private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(EngineAlgorithmView));
       this.engineLabel = new System.Windows.Forms.Label();
       this.createUserDefinedAlgorithmButton = new System.Windows.Forms.Button();
@@ -75,6 +74,6 @@
       this.tabControl.Controls.SetChildIndex(this.runsTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.resultsTabPage, 0);
+      this.tabControl.Controls.SetChildIndex(this.parametersTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.problemTabPage, 0);
-      this.tabControl.Controls.SetChildIndex(this.parametersTabPage, 0);
       // 
       // parametersTabPage
@@ -191,5 +190,5 @@
       this.engineComboBox.Location = new System.Drawing.Point(55, 6);
       this.engineComboBox.Name = "engineComboBox";
-      this.engineComboBox.Size = new System.Drawing.Size(610, 21);
+      this.engineComboBox.Size = new System.Drawing.Size(644, 21);
       this.engineComboBox.TabIndex = 1;
       this.engineComboBox.SelectedIndexChanged += new System.EventHandler(this.engineComboBox_SelectedIndexChanged);
@@ -204,5 +203,5 @@
       this.engineTabPage.Padding = new System.Windows.Forms.Padding(3);
       this.engineTabPage.Size = new System.Drawing.Size(705, 441);
-      this.engineTabPage.TabIndex = 3;
+      this.engineTabPage.TabIndex = 5;
       this.engineTabPage.Text = "Engine";
       this.engineTabPage.UseVisualStyleBackColor = true;
@@ -213,9 +212,10 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
+      this.engineViewHost.Caption = null;
       this.engineViewHost.Content = null;
       this.engineViewHost.Location = new System.Drawing.Point(6, 33);
       this.engineViewHost.Name = "engineViewHost";
       this.engineViewHost.ReadOnly = false;
-      this.engineViewHost.Size = new System.Drawing.Size(659, 335);
+      this.engineViewHost.Size = new System.Drawing.Size(693, 402);
       this.engineViewHost.TabIndex = 2;
       this.engineViewHost.ViewType = null;
@@ -260,9 +260,10 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
+      this.operatorGraphViewHost.Caption = null;
       this.operatorGraphViewHost.Content = null;
       this.operatorGraphViewHost.Location = new System.Drawing.Point(3, 33);
       this.operatorGraphViewHost.Name = "operatorGraphViewHost";
       this.operatorGraphViewHost.ReadOnly = true;
-      this.operatorGraphViewHost.Size = new System.Drawing.Size(699, 405);
+      this.operatorGraphViewHost.Size = new System.Drawing.Size(665, 338);
       this.operatorGraphViewHost.TabIndex = 0;
       this.operatorGraphViewHost.ViewType = null;
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3504)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3505)
@@ -47,4 +47,5 @@
       InitializeComponent();
       Caption = "Run Collection";
+      itemsGroupBox.Text = "Runs";
     }
 
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs	(revision 3504)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs	(revision 3505)
@@ -48,4 +48,5 @@
       this.globalScopeView = new HeuristicLab.Core.Views.ScopeView();
       this.engineTabPage.SuspendLayout();
+      this.operatorGraphTabPage.SuspendLayout();
       this.tabControl.SuspendLayout();
       this.parametersTabPage.SuspendLayout();
@@ -64,14 +65,30 @@
       this.createUserDefinedAlgorithmButton.Visible = false;
       // 
+      // engineComboBox
+      // 
+      this.engineComboBox.Size = new System.Drawing.Size(644, 21);
+      // 
+      // engineViewHost
+      // 
+      this.engineViewHost.Size = new System.Drawing.Size(693, 402);
+      // 
+      // openOperatorGraphButton
+      // 
+      this.toolTip.SetToolTip(this.openOperatorGraphButton, "Open Operator Graph");
+      // 
+      // newOperatorGraphButton
+      // 
+      this.toolTip.SetToolTip(this.newOperatorGraphButton, "New Operator Graph");
+      // 
       // tabControl
       // 
       this.tabControl.Controls.Add(this.globalScopeTabPage);
+      this.tabControl.Controls.SetChildIndex(this.engineTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.globalScopeTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.operatorGraphTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.runsTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.resultsTabPage, 0);
-      this.tabControl.Controls.SetChildIndex(this.engineTabPage, 0);
+      this.tabControl.Controls.SetChildIndex(this.parametersTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.problemTabPage, 0);
-      this.tabControl.Controls.SetChildIndex(this.parametersTabPage, 0);
       // 
       // newProblemButton
@@ -110,5 +127,5 @@
       this.globalScopeTabPage.Name = "globalScopeTabPage";
       this.globalScopeTabPage.Size = new System.Drawing.Size(705, 441);
-      this.globalScopeTabPage.TabIndex = 3;
+      this.globalScopeTabPage.TabIndex = 6;
       this.globalScopeTabPage.Text = "Global Scope";
       this.globalScopeTabPage.UseVisualStyleBackColor = true;
@@ -134,4 +151,5 @@
       this.engineTabPage.ResumeLayout(false);
       this.engineTabPage.PerformLayout();
+      this.operatorGraphTabPage.ResumeLayout(false);
       this.tabControl.ResumeLayout(false);
       this.parametersTabPage.ResumeLayout(false);
Index: trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.Designer.cs	(revision 3504)
+++ trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.Designer.cs	(revision 3505)
@@ -70,10 +70,10 @@
       // importButton
       // 
-      this.importButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
+      this.importButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.importButton.Location = new System.Drawing.Point(0, 399);
+      this.importButton.Location = new System.Drawing.Point(0, 52);
       this.importButton.Name = "importButton";
       this.importButton.Size = new System.Drawing.Size(529, 23);
-      this.importButton.TabIndex = 5;
+      this.importButton.TabIndex = 4;
       this.importButton.Text = "&Import from TSPLIB";
       this.importButton.UseVisualStyleBackColor = true;
@@ -87,9 +87,9 @@
       this.tabControl.Controls.Add(this.parametersTabPage);
       this.tabControl.Controls.Add(this.visualizationTabPage);
-      this.tabControl.Location = new System.Drawing.Point(0, 52);
+      this.tabControl.Location = new System.Drawing.Point(0, 81);
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
       this.tabControl.Size = new System.Drawing.Size(529, 341);
-      this.tabControl.TabIndex = 4;
+      this.tabControl.TabIndex = 5;
       // 
       // parametersTabPage
@@ -113,4 +113,5 @@
       this.parameterCollectionView.Location = new System.Drawing.Point(6, 6);
       this.parameterCollectionView.Name = "parameterCollectionView";
+      this.parameterCollectionView.ReadOnly = false;
       this.parameterCollectionView.Size = new System.Drawing.Size(509, 303);
       this.parameterCollectionView.TabIndex = 0;
@@ -136,4 +137,5 @@
       this.pathTSPTourView.Location = new System.Drawing.Point(6, 6);
       this.pathTSPTourView.Name = "pathTSPTourView";
+      this.pathTSPTourView.ReadOnly = false;
       this.pathTSPTourView.Size = new System.Drawing.Size(509, 303);
       this.pathTSPTourView.TabIndex = 0;